=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2009-05-05 06:02:29 +0000
+++ bzrlib/osutils.py	2009-05-05 16:57:19 +0000
@@ -97,11 +97,14 @@
 
     :param paths: A container (and hence not None) of paths.
     :return: A set of paths sufficient to include everything in paths via
-        is_inside_any, drawn from the paths parameter.
+        is_inside, drawn from the paths parameter.
     """
     search_paths = []
-    sorted_paths = list(paths)
-    sorted_paths.sort()
+
+    def sort_key(path):
+        return path.split('/')
+    sorted_paths = sorted(list(paths), key=sort_key)
+
     for path in sorted_paths:
         if len(search_paths) == 0:
             # Result is empty, add first path

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2009-04-17 14:03:32 +0000
+++ bzrlib/tests/test_osutils.py	2009-05-05 16:57:19 +0000
@@ -703,6 +703,8 @@
             osutils.minimum_path_selection(['a/', 'b']))
         self.assertEqual(set(['a/', 'b']),
             osutils.minimum_path_selection(['a/c', 'a/', 'b']))
+        self.assertEqual(set(['a-b', 'a', 'a0b']),
+            osutils.minimum_path_selection(['a-b', 'a/b', 'a0b', 'a']))
 
     def test_mkdtemp(self):
         tmpdir = osutils._win32_mkdtemp(dir='.')

